diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
similarity index 74%
rename from src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
rename to game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index cc674e2b1..765a860fc 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -8,18 +8,18 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.net.packet.BoatControlPacket;
-import net.minecraft.core.net.packet.ChatPacket;
-import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
-import net.minecraft.core.net.packet.MovePlayerPacket;
-import net.minecraft.core.net.packet.ContainerClosePacket;
-import net.minecraft.core.net.packet.UpdateCreativeInventoryPacket;
-import net.minecraft.core.net.packet.SetHotbarOffsetPacket;
-import net.minecraft.core.net.packet.GuidebookPacket;
-import net.minecraft.core.net.packet.PlayerActionPacket;
-import net.minecraft.core.net.packet.AnimatePacket;
-import net.minecraft.core.net.packet.CustomPayloadPacket;
-import net.minecraft.core.net.packet.RespawnPacket;
+import net.minecraft.core.net.packet.PacketBoatControl;
+import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketUpdatePlayerState;
+import net.minecraft.core.net.packet.PacketMovePlayer;
+import net.minecraft.core.net.packet.PacketContainerClose;
+import net.minecraft.core.net.packet.PacketUpdateCreativeInventory;
+import net.minecraft.core.net.packet.PacketSetHotbarOffset;
+import net.minecraft.core.net.packet.PacketGuidebook;
+import net.minecraft.core.net.packet.PacketPlayerAction;
+import net.minecraft.core.net.packet.PacketAnimate;
+import net.minecraft.core.net.packet.PacketCustomPayload;
+import net.minecraft.core.net.packet.PacketRespawn;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
@@ -89,10 +89,10 @@ public class PlayerLocalMultiplayer extends PlayerLocal
         {
             if(flag)
             {
-                sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_SNEAK));
+                sendQueue.addToSendQueue(new PacketUpdatePlayerState(PacketUpdatePlayerState.STATE_SNEAK));
             } else
             {
-                sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_UN_SNEAK));
+                sendQueue.addToSendQueue(new PacketUpdatePlayerState(PacketUpdatePlayerState.STATE_UN_SNEAK));
             }
             wasSneaking = flag;
         }
@@ -108,30 +108,30 @@ public class PlayerLocalMultiplayer extends PlayerLocal
         {
             if(flag2)
             {
-                sendQueue.addToSendQueue(new MovePlayerPacket.Pos(xd, -999D, zd, onGround));
+                sendQueue.addToSendQueue(new PacketMovePlayer.Pos(xd, -999D, zd, onGround));
             } else
             {
-                sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(xd, -999D, zd, yRot, xRot, onGround));
+                sendQueue.addToSendQueue(new PacketMovePlayer.PosRot(xd, -999D, zd, yRot, xRot, onGround));
             }
             flag1 = false;
         } else
         if(flag1 && flag2)
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(x, bb.minY, z, yRot, xRot, onGround));
+            sendQueue.addToSendQueue(new PacketMovePlayer.PosRot(x, bb.minY, z, yRot, xRot, onGround));
             noSendTime = 0;
         } else
         if(flag1)
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket.Pos(x, bb.minY, z, onGround));
+            sendQueue.addToSendQueue(new PacketMovePlayer.Pos(x, bb.minY, z, onGround));
             noSendTime = 0;
         } else
         if(flag2)
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket.Rot(yRot, xRot, onGround));
+            sendQueue.addToSendQueue(new PacketMovePlayer.Rot(yRot, xRot, onGround));
             noSendTime = 0;
         } else
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket(onGround));
+            sendQueue.addToSendQueue(new PacketMovePlayer(onGround));
             if(wasOnGround != onGround || noSendTime > 200)
             {
                 noSendTime = 0;
@@ -157,7 +157,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal
 
     @Override
     public void dropCurrentItem(boolean dropFullStack) {
-        sendQueue.addToSendQueue(new PlayerActionPacket(dropFullStack ? PlayerActionPacket.ACTION_DROP_ITEM_STACK : PlayerActionPacket.ACTION_DROP_ITEM_SINGLE, 0, 0, 0, Side.NONE, 0.0, 0.0));
+        sendQueue.addToSendQueue(new PacketPlayerAction(dropFullStack ? PacketPlayerAction.ACTION_DROP_ITEM_STACK : PacketPlayerAction.ACTION_DROP_ITEM_SINGLE, 0, 0, 0, Side.NONE, 0.0, 0.0));
     }
 
     private void sendInventoryChanged()
@@ -172,42 +172,42 @@ public class PlayerLocalMultiplayer extends PlayerLocal
     @Override
 	public void sendChatMessage(String s)
     {
-        sendQueue.addToSendQueue(new ChatPacket(s, AES.clientKeyChain));
+        sendQueue.addToSendQueue(new PacketChat(s, AES.clientKeyChain));
     	addToSendHistory(s);
     }
     
     @Override
 	public void updateCreativeInventory(int page, String searchText)
     {
-    	sendQueue.addToSendQueue(new UpdateCreativeInventoryPacket(craftingInventory.containerId, page, searchText));
+    	sendQueue.addToSendQueue(new PacketUpdateCreativeInventory(craftingInventory.containerId, page, searchText));
     }
 
     @Override
     public void setHotbarOffset(int offset)
     {
         super.setHotbarOffset(offset);
-        sendQueue.addToSendQueue(new SetHotbarOffsetPacket(offset));
+        sendQueue.addToSendQueue(new PacketSetHotbarOffset(offset));
     }
 
     @Override
 	public void displayGuidebookScreen()
     {
         mc.displayScreen(new ScreenGuidebook(mc.currentScreen));
-        sendQueue.addToSendQueue(new GuidebookPacket(mc.currentScreen instanceof ScreenGuidebook));
+        sendQueue.addToSendQueue(new PacketGuidebook(mc.currentScreen instanceof ScreenGuidebook));
     }
 
     @Override
 	public void swingItem()
     {
         super.swingItem();
-        sendQueue.addToSendQueue(new AnimatePacket(this, 1));
+        sendQueue.addToSendQueue(new PacketAnimate(this, 1));
     }
 
     @Override
 	public void respawnPlayer()
     {
         sendInventoryChanged();
-        sendQueue.addToSendQueue(new RespawnPacket((byte)dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(world.worldType)));
+        sendQueue.addToSendQueue(new PacketRespawn((byte)dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(world.worldType)));
     }
 
     @Override
@@ -219,7 +219,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal
     @Override
 	public void closeScreen()
     {
-        sendQueue.addToSendQueue(new ContainerClosePacket(craftingInventory.containerId));
+        sendQueue.addToSendQueue(new PacketContainerClose(craftingInventory.containerId));
         inventory.setHeldItemStack(null);
         super.closeScreen();
     }
@@ -269,18 +269,18 @@ public class PlayerLocalMultiplayer extends PlayerLocal
     	data[2] = (byte) (rotationLockVertical != null ? rotationLockVertical.getId() : -1);
     	data[3] = (byte) (placementModeOverride != null ? placementModeOverride.index() : -1);
     	
-    	sendQueue.addToSendQueue(new CustomPayloadPacket("BTA|RotationLock", data));
+    	sendQueue.addToSendQueue(new PacketCustomPayload("BTA|RotationLock", data));
     }
     
     @Override
     public void pickBlock(int x, int y, int z) {
-    	sendQueue.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
+    	sendQueue.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
     }
 
     @Override
     public void sendSpecialVehiclePacket() {
         if (vehicle instanceof EntityBoat) {
-            sendQueue.addToSendQueue(new BoatControlPacket((EntityBoat) vehicle));
+            sendQueue.addToSendQueue(new PacketBoatControl((EntityBoat) vehicle));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
similarity index 97%
rename from src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
rename to game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
index 0b184bcee..05400c3d4 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
@@ -153,4 +153,10 @@ public class PlayerRemote extends Player
 	public void sendStatusMessage(String message) {
 		
 	}
+
+    @Override
+    public float getHeadHeight()
+    {
+        return getHeightOffset();
+    }
 }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenConnecting.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
similarity index 97%
rename from src/main/java/net/minecraft/client/gui/ScreenConnecting.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
index 2a5f3399b..db864d7c9 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
@@ -4,7 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.packet.PreLoginPacket;
+import net.minecraft.core.net.packet.PacketPreLogin;
 import org.slf4j.Logger;
 
 import java.net.ConnectException;
@@ -27,7 +27,7 @@ public class ScreenConnecting extends Screen
                 {
                     return;
                 }
-                clientHandler.addToSendQueue(new PreLoginPacket(mc.session.username));
+                clientHandler.addToSendQueue(new PacketPreLogin(mc.session.username));
             }
             catch(UnknownHostException unknownhostexception)
             {
diff --git a/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
index 03be6e8fa..f83249655 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.net.handler.PacketHandlerClient;
-import net.minecraft.core.net.packet.KeepAlivePacket;
+import net.minecraft.core.net.packet.PacketKeepAlive;
 import net.minecraft.core.lang.I18n;
 
 public class ScreenDownloadTerrain extends Screen
@@ -30,7 +30,7 @@ public class ScreenDownloadTerrain extends Screen
         updateCounter++;
         if(updateCounter % 20 == 0)
         {
-            netHandler.addToSendQueue(new KeepAlivePacket());
+            netHandler.addToSendQueue(new PacketKeepAlive());
         }
         if(netHandler != null)
         {
diff --git a/src/main/java/net/minecraft/client/gui/ScreenGameOver.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
similarity index 95%
rename from src/main/java/net/minecraft/client/gui/ScreenGameOver.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
index eb0c99ed2..04f3aed52 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.packet.KeepAlivePacket;
+import net.minecraft.core.net.packet.PacketKeepAlive;
 import net.minecraft.core.player.gamemode.Gamemode;
 import org.lwjgl.opengl.GL11;
 
@@ -20,7 +20,7 @@ public class ScreenGameOver extends Screen
         tickCount++;
         if (mc.isMultiplayerWorld() && mc.thePlayer instanceof PlayerLocalMultiplayer && tickCount % 10 == 0){
             PlayerLocalMultiplayer clientPlayerMP = (PlayerLocalMultiplayer) mc.thePlayer;
-            clientPlayerMP.sendQueue.addToSendQueue(new KeepAlivePacket());
+            clientPlayerMP.sendQueue.addToSendQueue(new PacketKeepAlive());
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
similarity index 95%
rename from src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
index c015c5720..a308de9fc 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.packet.SetItemNamePacket;
+import net.minecraft.core.net.packet.PacketSetItemName;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -53,7 +53,7 @@ public class ScreenLabelEditor extends Screen
 
             if (mc.currentWorld.isClientSide)
             {
-                mc.getSendQueue().addToSendQueue(new SetItemNamePacket(slot, text));
+                mc.getSendQueue().addToSendQueue(new PacketSetItemName(slot, text));
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
similarity index 98%
rename from src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 284e13ab8..fff1eafad 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -7,7 +7,9 @@ import java.io.InputStream;
 import java.io.InputStreamReader;
 import java.net.URI;
 import java.nio.charset.StandardCharsets;
+import java.text.SimpleDateFormat;
 import java.util.ArrayList;
+import java.util.Date;
 import java.util.List;
 import java.util.Random;
 
@@ -21,6 +23,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
+import net.minecraft.core.Version;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
@@ -60,6 +63,7 @@ public class ScreenMainMenu extends Screen
     private int indexToDraw = 0;
     private int codeProgress = 0;
     private boolean showBuildTime = false;
+    private String buildTimeString = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(Version.BUILD_TIME));
     
     static {
     	loadLogo();
@@ -339,7 +343,7 @@ public class ScreenMainMenu extends Screen
         GL11.glPopMatrix();
         int versionTextColor = mc.gameSettings.alphaMenu.value || !mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
         if (showBuildTime) {
-            drawString(font, Global.BUILD_TIME, 2, 2, versionTextColor);
+            drawString(font, buildTimeString, 2, 2, versionTextColor);
         } else {
             drawString(font, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
         }
@@ -436,7 +440,7 @@ public class ScreenMainMenu extends Screen
 
                         GL11.glTranslatef((float)var7, (float)var6, var10);
                         GL11.glScalef(var11, var11, var11);
-                        var5.renderBlockAsItem(Tessellator.instance, BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[indexToDraw]), BLOCKS_TO_DRAW[indexToDraw], var12);
+                        var5.renderBlockAsItem(Tessellator.instance, BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[indexToDraw]), var12);
                         GL11.glPopMatrix();
                     }
                 }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
similarity index 94%
rename from src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
index af589e346..323df04c2 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
@@ -7,7 +7,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
-import net.minecraft.core.net.packet.SetMobSpawnerPacket;
+import net.minecraft.core.net.packet.PacketSetMobSpawner;
 import net.minecraft.core.util.collection.NamespaceID;
 
 import java.lang.reflect.Modifier;
@@ -68,7 +68,7 @@ public class ScreenMobPicker
                         }
                         spawner.setMobId(mobId);
                     } else {
-                        mc.getSendQueue().addToSendQueue(new SetMobSpawnerPacket(x, y, z, EntityDispatcher.classForId(mobId)));
+                        mc.getSendQueue().addToSendQueue(new PacketSetMobSpawner(x, y, z, EntityDispatcher.classForId(mobId)));
                     }
                 }
                 shouldClose = true;
diff --git a/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
similarity index 99%
rename from src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 2f0f807b9..5293cb726 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -14,7 +14,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
-import net.minecraft.core.util.helper.ScreenShot;
+import net.minecraft.client.util.helper.ScreenShot;
 
 import java.io.File;
 import java.util.Locale;
diff --git a/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
similarity index 96%
rename from src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 1e7dc56f8..78734166e 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -5,7 +5,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
-import net.minecraft.core.net.packet.SignUpdatePacket;
+import net.minecraft.core.net.packet.PacketSignUpdate;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
@@ -47,7 +47,7 @@ public class ScreenSignEditor extends Screen
         // but thaboar was getting a crash from the world being null
         if(mc.currentWorld != null && mc.currentWorld.isClientSide)
         {
-            mc.getSendQueue().addToSendQueue(new SignUpdatePacket(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
+            mc.getSendQueue().addToSendQueue(new PacketSignUpdate(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
similarity index 95%
rename from src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
rename to game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
index 4006dac6b..922125d27 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
@@ -6,7 +6,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.net.packet.PacketCustomPayload;
 import net.minecraft.core.util.collection.NamespaceID;
 
 import java.lang.reflect.Modifier;
@@ -58,7 +58,7 @@ public class ScreenWandMobPicker extends Screen {
                         if (!mc.currentWorld.isClientSide) {
                             wand.getData().putString("monster", mobId);
                         } else {
-                            mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
+                            mc.getSendQueue().addToSendQueue(new PacketCustomPayload("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
                         }
                     }
                     shouldClose = true;
diff --git a/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
similarity index 99%
rename from src/main/java/net/minecraft/client/gui/TooltipElement.java
rename to game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index a6e2035c4..bc12a1438 100644
--- a/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -260,6 +260,7 @@ public class TooltipElement extends Gui
             }
 
 			if(debug) {
+                text.append('\n').append(TextFormatting.LIGHT_GRAY).append(itemStack.getItem().namespaceID);
                 text.append('\n').append(TextFormatting.LIGHT_GRAY).append(itemStack.getItemKey());
 				CompoundTag data = itemStack.getData();
 				if(data != null) {
diff --git a/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
similarity index 99%
rename from src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
rename to game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 08beed35b..d33404c98 100644
--- a/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -23,7 +23,7 @@ import net.minecraft.client.net.command.ClientCommandSource;
 import net.minecraft.client.render.Font;
 import net.minecraft.core.net.command.*;
 import net.minecraft.core.net.command.util.CommandHelper;
-import net.minecraft.core.net.packet.RequestCommandManagerPacket;
+import net.minecraft.core.net.packet.PacketRequestCommandManager;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -229,7 +229,7 @@ public class GuiElementChatSuggestions extends Gui {
 
         if (this.mc.isMultiplayerWorld()) {
             this.parseResults = null;
-            this.mc.getSendQueue().addToSendQueue(new RequestCommandManagerPacket(this.mc.thePlayer.username, text, cursor));
+            this.mc.getSendQueue().addToSendQueue(new PacketRequestCommandManager(this.mc.thePlayer.username, text, cursor));
         } else {
             if (stringReader.canRead() && stringReader.peek() == '/') stringReader.skip();
             CommandDispatcher<CommandSource> dispatcher = this.getManager().getDispatcher();
diff --git a/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
rename to game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
index bc8a452aa..454f11fc3 100644
--- a/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui.chat;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.net.handler.PacketHandlerClient;
-import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
+import net.minecraft.core.net.packet.PacketUpdatePlayerState;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.lang.I18n;
@@ -65,7 +65,7 @@ public class ScreenSleepMP extends ScreenChat
         if(mc.thePlayer instanceof PlayerLocalMultiplayer)
         {
             PacketHandlerClient sendQueue = ((PlayerLocalMultiplayer)mc.thePlayer).sendQueue;
-            sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_LEAVE_BED));
+            sendQueue.addToSendQueue(new PacketUpdatePlayerState(PacketUpdatePlayerState.STATE_LEAVE_BED));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
similarity index 99%
rename from src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
rename to game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 5eba67777..d940e33a1 100644
--- a/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -16,7 +16,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.net.packet.PacketCustomPayload;
 import net.minecraft.core.player.inventory.menu.MenuFlag;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -412,7 +412,7 @@ public class ScreenFlagEditor
         {
     		// Flag packet needs to be sent before the close screen packet is sent!
     		if(mc.currentWorld.isClientSide) {
-    			mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|Flag", flagEntity.flagColors));
+    			mc.getSendQueue().addToSendQueue(new PacketCustomPayload("BTA|Flag", flagEntity.flagColors));
     		}
             mc.thePlayer.closeScreen();
         }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java
similarity index 98%
rename from src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java
rename to game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java
index 371bccdb9..2d101d333 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterLabel.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.guidebook.crafting.displays;
 
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabel;
@@ -25,7 +26,7 @@ public class DisplayAdapterLabel implements RecipeDisplayAdapter<RecipeEntryLabe
             while (blocksAdded < 50) {
                 Block b = null;
                 while (b == null) {
-                    b = Block.getBlock(lastId + offset++);
+                    b = Blocks.getBlock(lastId + offset++);
                 }
                 randomOptions[blocksAdded++] = b;
                 lastId = b.id;
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
similarity index 93%
rename from src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
rename to game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index c805c8b50..9a65149f5 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -216,19 +216,8 @@ public class GuidebookPageMob
 
         if (discovered) {
             if (mouseX > x + 9 && mouseX < x + 9 + 52 && mouseY > y + 9 && mouseY < y + 9 + 70) {
-                // TODO possibly replace with a function to be called inside the Entity itself?
-//                int highestSkinVariant = Global.accessor.getSkinVariantList().getNumSkinsForEntity(mobClass) - 1;
-//                if (highestSkinVariant > 0) {
-//                    int newSkinVariant = (example.getSkinVariant() + 1) % (highestSkinVariant + 1);
-//                    example.setSkinVariant(newSkinVariant);
-//                }
-                if (example instanceof MobFireflyCluster){
-                    MobFireflyCluster.FireflyColor color = MobFireflyCluster.FireflyColor.fireFlyColors.get(
-                            ((MobFireflyCluster) example).getColor().getId() + 1 % MobFireflyCluster.FireflyColor.fireFlyColors.size());
-                    ((MobFireflyCluster) example).setColor(color == null ? MobFireflyCluster.FireflyColor.GREEN : color);
-                }
                 String livingSound = example.getLivingSound();
-                if (livingSound != null) {
+                if (example.cycleVariant() && livingSound != null) {
                     Minecraft mc = Minecraft.getMinecraft(this);
                     Random random = new Random();
                     mc.currentWorld.playSoundAtEntity(null, mc.thePlayer, livingSound, 0.25f, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
